> For the complete documentation index, see [llms.txt](https://docs.adsecure.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.adsecure.com/api/models/frame.md).

# Frame

A frame recorded during the [Analysis](/docs/development/concepts.md#analysis).

```typescript
interface Frame {
  id: string;
  parentId: string;
  loaderId: string;
  delay: string;
  navigationReason: NavigationReason; // "INITIAL" | "FORM_SUBMISSION_GET" | "FORM_SUBMISSION_POST" | "HTTP_HEADER_REFRESH" | "SCRIPT_INITIATED" | "META_TAG_REFRESH" | "PAGE_BLOCK_INTERSTITIAL" | "RELOAD" | "UNKNOWN"
  url: string;
  securityOrigin: string;
  mimeType: string;
  unreachableUrl: string;
  history: FrameHistory[];
}
```

### Fields

* [`id`](#id)
* [`parentId`](#parentid)
* [`loaderId`](#loaderid)
* [`delay`](#delay)
* [`navigationReason`](#navigationreason)
* [`url`](#url)
* [`securityOrigin`](#securityorigin)
* [`mimeType`](#mimetype)
* [`unreachableUrl`](#unreachableurl)
* [`history`](#history)

## Fields

***

### `id`

```
version  : 1.0.0
stability: stable
```

```typescript
id: string;
```

Id of the [`Frame`](/api/models/frame.md).

***

### `parentId`

```
version  : 1.0.0
stability: stable
```

```typescript
parentId: string;
```

Parent [`Frame`](/api/models/frame.md) identifier.

***

### `loaderId`

```
version  : 1.0.0
stability: stable
```

```typescript
loaderId: string;
```

Identifier of the loader that loaded the [`Frame`](/api/models/frame.md).

***

### `delay`

```
version  : 1.0.0
stability: stable
```

```typescript
delay: string;
```

Number of seconds in which the navigation is scheduled to start.

***

### `navigationReason`

```
version  : 1.0.0
stability: stable
```

```typescript
navigationReason: NavigationReason;
```

```typescript
enum NavigationReason {
  Initial = "INITIAL",
  FormSubmissionGet = "FORM_SUBMISSION_GET",
  FormSubmissionPost = "FORM_SUBMISSION_POST",
  HttpHeaderRefresh = "HTTP_HEADER_REFRESH",
  ScriptInitiated = "SCRIPT_INITIATED",
  MetaTagRefresh = "META_TAG_REFRESH",
  PageBlockInterstitial = "PAGE_BLOCK_INTERSTITIAL",
  Reload = "RELOAD",
  Unknown = "UNKNOWN",
}
```

The reason that initiates the [`Frame`](/api/models/frame.md) navigation.

***

### `url`

```
version  : 1.0.0
stability: stable
```

```typescript
url: string;
```

[`Frame`](/api/models/frame.md) document's URL.

***

### `securityOrigin`

```
version  : 1.0.0
stability: stable
```

```typescript
securityOrigin: string;
```

[`Frame`](/api/models/frame.md) document's security origin.

***

### `mimeType`

```
version  : 1.0.0
stability: stable
```

```typescript
mimeType: string;
```

[`Frame`](/api/models/frame.md) document's mime type as determined by the browser.

***

### `unreachableUrl`

```
version  : 1.0.0
stability: stable
```

```typescript
unreachableUrl: string;
```

If the [`Frame`](/api/models/frame.md) failed to load, this will contain the URL that could not be loaded.

***

### `history`

```
version  : 1.0.0
stability: stable
```

```typescript
history: FrameHistory[];
```

```typescript
interface FrameHistory {
  data: string;
  type: FrameHistoryType;
  timestamp: MonotonicTime;
  targetVersion: string;
}
```

```typescript
enum FrameHistoryType {
  Landing = "LANDING",
  Lifecycle = "LIFECYCLE",
  Navigation = "NAVIGATION",
  Redirection = "REDIRECTION",
  ScheduledNavigation = "SCHEDULED_NAVIGATION",
  Unknown = "UNKNOWN",
}
```

The [`Frame`](/api/models/frame.md)'s history records.

> The history's `timestamp` is a baseline in seconds (see [`MonotonicTime`](/api/terms.md#monotonictime)).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.adsecure.com/api/models/frame.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
